<?php echo $header; ?>

<ul class="breadcrumb">
    <li><a href="<?php echo site_url('groups'); ?>"><?php echo lang('header_tab_sourcegroups'); ?></a> <span class="divider">/</span></li>
    <li><a href="<?php echo site_url('groups/' . $group->gid); ?>"><?php echo lang('breadcrumb_sourcegroup'); ?> - <?php echo $group->name; ?></a> <span class="divider">/</span></li>
    <li class="active"><?php echo lang('edit_sourcegroup_edit'); ?></li>
</ul>

<script type="text/javascript">
var SOURCE_LIST = [];

$(document).ready(function() {

    // Load a list of current sources
    $.post(site_url + '/api/groups/read_source_associations', { 'q[gid]': group_id }, function(sources) {
        if (sources.length) {
            $.each(sources, function(key, value) {
                SOURCE_LIST.push(value.sid);
                $('#group_sourcelist').append('<option value="' + value.sid + '">' + value.name + '</option>');
            });
        }
        load_all_sources();
    });

    // Do add/remove additions

    $('#add_button').click(function() {
        var opsid = $('#sourcelist').val() || [];
        if (opsid.length > 0) {
            $.each(opsid, function(key, sid) {
                var name = $('#sourcelist option[value="' + sid + '"]').text();
                $('#group_sourcelist').append('<option value="' + sid + '">' + name + '</option>');
            });
        }
        $('#sourcelist option:selected').remove();
    });

    $('#remove_button').click(function() {
        var opsid = $('#group_sourcelist').val() || [];
        if (opsid.length > 0) {
            $.each(opsid, function(key, sid) {
                var name = $('#group_sourcelist option[value="' + sid + '"]').text();
                $('#sourcelist').append('<option value="' + sid + '">' + name + '</option>');
            });
        }
        $('#group_sourcelist option:selected').remove();
    });

    // SAve updated group
    $('#save_group').click(function() {
        $('#display_error').hide();
        $('#display_message').hide();
        $('#group_sourcelist option').attr('selected', 'selected');
        var selected_sids = $('#group_sourcelist').val() || [];
        if (selected_sids.length == 0) { $('#display_error').html("<?php echo lang('create_sourcegroup_no_sources'); ?>").show(); }
        else {
            $.post(site_url + '/api/groups/delete_source_associations', { 'q[gid]': group_id }, function(data) {
                if (data.status == 'success') {
                    $.post(site_url + '/api/groups/add_source_associations', { 'q[gid]': group_id, 'q[sid]': selected_sids }, function(data) {
                        $('#display_message').html("<?php echo lang('edit_sourcegroup_save'); ?>").show();
                    });
                } else {
                    // Display error
                    $('#display_error').html(data.error).show();
                }
            });
        }
    });

});

// Load a list of sources
function load_all_sources()
{
    $.post(site_url + '/api/sources/read', { }, function(sources) {
        if (sources.length) {
            $.each(sources, function(key, value) {
                if ($.inArray(value.sid, SOURCE_LIST) == -1) { // Remove sources from list that are already in the group
                    $('#sourcelist').append('<option value="' + value.sid + '">' + value.name + '</option>');
                }
            });
        }
    });
}
</script>

<div class="container">
    <?php echo $tabs; ?>
    <div class="row-fluid">
        <div class="span12">
            <h3><?php echo lang('edit_sourcegroup_heading');?></h3>
            <p><?php echo lang('create_sourcegroup_subheading');?></p>
            <div style="border-bottom: 1px solid #DDD; margin-bottom: 20px;">
            </div>
            <div class="hide alert alert-error" id="display_error"></div>
            <div class="hide alert alert-success" id="display_message"></div>
            <div>
                <table>
                    <tr>
                        <td class="form-left"><?php echo lang('create_sourcegroup_name'); ?>*:</td>
                        <td>
                            <div><input type="text" name="group_name" style="margin: 0;" value="<?php if (set_value('group_name')) { echo set_value('group_name'); } else { echo $group->name; } ?>" disabled></div>
                            <div style="font-size: 11px; padding-bottom: 10px;"><?php echo lang('create_sourcegroup_name_desc'); ?></div>
                        </td>
                    </tr>
                    <tr>
                        <td class="form-left"><?php echo lang('create_sourcegroup_sources'); ?>:</td>
                        <td>
                            <div style="float: left;">
                                <select size="8" multiple name="group_sourcelist[]" id="group_sourcelist">
                                </select>
                            </div>
                            <div style="float: left; padding: 0 10px;">
                                <button type="button" class="btn btn-small" title="<?php echo lang('create_sourcegroup_add'); ?>" style="display: block; margin-bottom: 10px;" id="add_button"><i class="icon-arrow-left"></i></button>
                                <button type="button" class="btn btn-small btn-danger" title="<?php echo lang('create_sourcegroup_remove'); ?>" style="display: block;" id="remove_button"><i class="icon-remove icon-white"></i></button>
                            </div>
                            <div style="float: left;">
                                <select size="8" multiple id="sourcelist">
                                </select>
                            </div>
                            <div class="clear"></div>
                        </td>
                    </tr>
                    <tr>
                        <td class="form-left" style="padding-top: 0;"><?php echo lang('create_sourcegroup_lifetime'); ?>:</td>
                        <td><?php echo lang('create_sourcegroup_lifetime_text'); ?></td>
                    </tr>
                </table>
            </div>
            <div style="margin-top: 15px;" class="form-actions">
                <button type="button" id="save_group" class="btn btn-primary"><?php echo lang('save_button'); ?></button>
                <a href="<?php echo site_url('groups/' . $group->gid); ?>" class="btn"><?php echo lang('cancel_button'); ?></a>
            </div>
        </div>
    </div>
</div>

<?php echo $footer; ?>